package com.samknows.measurement.net;


import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.SocketException;

import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.samknows.measurement.SKAppSettings;

import android.content.Context;
import android.util.Log;



public class RequestScheduleAnonymousAction {
	
	private static final String TAG = RequestScheduleAnonymousAction.class.getSimpleName();
	
	public JSONArray testServer = null;
	public JSONObject testInfo = null;
	
	private String connect_address = "0.0.0.0";
	private int connect_port = 1025;
	private String connect_id = "id";
	private String connect_pw = "pw";
	private String file_path = "";
	
	public RequestScheduleAnonymousAction(Context c){

	}
	
	public void execute() {
		
		ByteArrayOutputStream os = new ByteArrayOutputStream(2*1024);	
		try {
			FTPClient client = new FTPClient();
			client.connect(connect_address, connect_port);
			client.login(connect_id, connect_pw);
			client.enterLocalPassiveMode();
			client.setFileType(FTP.BINARY_FILE_TYPE);
			client.retrieveFile(file_path+"/testServer.json", os);
			
			
			String string = new String(os.toByteArray());
			testServer = new JSONArray(string);;
			
			os.reset();
			client.retrieveFile(file_path+"/scenario.json", os);
			string = new String(os.toByteArray());
			testInfo = new JSONObject(string);
			
			os.close();
			client.logout();
			client.disconnect();
		} catch (SocketException e) {
			Log.e(TAG,""+e.getMessage());
		} catch (IOException e) {
			Log.e(TAG,""+e.getMessage());
		} catch (JSONException e) {
			Log.e(TAG,""+e.getMessage());
		}
	}

	public boolean isSuccess() {
		if(testServer != null && testInfo != null) return true;
		return false;
	}

	

}
