package com.samknows.measurement.statemachine;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class TransitionAnonymous extends Transition {
	private static final String TYPE = TransitionAnonymous.class.getName();
	private static final Map<State, String[]> transitionFunction;
	static {
		Map<State, String[]> tmp= new HashMap<State, String[]>();
		tmp.put(State.NONE, new String[] {"OK:DOWNLOAD_CONFIG_ANONYMOUS"});
		tmp.put(State.DOWNLOAD_CONFIG_ANONYMOUS, new String[] {"NOT_OK:RUN_INIT_TESTS","OK:SHUTDOWN"});
		tmp.put(State.RUN_INIT_TESTS, new String[] {"OK:SHUTDOWN"});
		tmp.put(State.SHUTDOWN, new String[] {"OK:NONE"});
		transitionFunction = Collections.unmodifiableMap(tmp);
	}

	@Override
	public String getType() {
		return TYPE;
	}

	@Override
	protected Map<State, String[]> getTransition() {
		return transitionFunction;
	}

}
