package com.samknows.measurement.statemachine;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class TransitionBackground extends Transition {
	private static final String TYPE = TransitionBackground.class.getName();
	private static final Map<State, String[]> transitionFunction;
	static {
		Map<State, String[]> tmp= new HashMap<State, String[]>();
		tmp.put(State.NONE, new String[] {"OK:EXECUTE_QUEUE"});
		tmp.put(State.EXECUTE_QUEUE, new String[] {"NOT_OK:SHUTDOWN","OK:SHUTDOWN"});
		tmp.put(State.SHUTDOWN, new String[] {"OK:NONE"});
		transitionFunction = Collections.unmodifiableMap(tmp);
	}

	@Override
	public String getType() {
		return TYPE;
	}

	@Override
	protected Map<State, String[]> getTransition() {
		return transitionFunction;
	}

}
